;;;; expand-full.scm
;;;; Kon Lovett, Apr '09

;;;

(module expand-full

  (expand* pretty-print-expand* ppexpand*)

  (import scheme chicken
          (only csi toplevel-command)
          (only extras pretty-print)
          (only srfi-1 map!))
  
  (require-library extras srfi-1)

;;;

;;

(define (expand* form #!optional se)
  (let expd ((form form))
    (let ((form* (cond ((list? form) (map! expd (expand form se)) )
                       ((pair? form) (cons (expd (car form)) (expd (cdr form))) )
                       (else (expand form se) ) ) ) )
      (if (equal? form form*) form
          (expd form*) ) ) ) )

;;

(define (pretty-print-expand* form #!optional se)
  (pretty-print (strip-syntax (expand* form se)))
  (void) )

(define ppexpand* pretty-print-expand*)

;;;

(when (feature? csi:)
  (toplevel-command 'x*
    (lambda () (ppexpand* (read)))
    ",x* EXP           Pretty print fully expanded expression EXP") )

) ;module expand-full
